Imports GalaSoft.MvvmLight.Threading
Imports Microsoft.Devices.Sensors

Namespace CompassSample.Model
	Public Class SensorService
		Implements ISensorService
        Private orientationCallback As Action(Of Double)
        Private _compass As Compass

        Public Sub RegisterForHeading(ByVal callback As Action(Of Double)) Implements ISensorService.RegisterForHeading
            orientationCallback = callback

            If _compass Is Nothing Then
                _compass = New Compass()
                AddHandler _compass.CurrentValueChanged, AddressOf CompassCurrentValueChanged
                _compass.Start()
            End If
        End Sub

        Private Sub CompassCurrentValueChanged(ByVal sender As Object, ByVal e As SensorReadingEventArgs(Of CompassReading))
            If orientationCallback IsNot Nothing Then
                DispatcherHelper.CheckBeginInvokeOnUI(Sub()
                                                          orientationCallback(e.SensorReading.TrueHeading)
                                                      End Sub)
            End If
        End Sub

	End Class
End Namespace
