Imports CompassSample.Model
Imports GalaSoft.MvvmLight

Namespace CompassSample.ViewModel

    Public Class MainViewModel
        Inherits ViewModelBase
        ''' <summary>
        ''' The <see cref="Heading" /> property's name.
        ''' </summary>
        Public Const HeadingPropertyName As String = "Heading"

        Private _heading As String

        ''' <summary>
        ''' Sets and gets the Heading property.
        ''' Changes to that property's value raise the PropertyChanged event. 
        ''' </summary>
        Public Property Heading() As String
            Get
                Return _heading
            End Get
            Set(ByVal value As String)
                MyBase.Set(HeadingPropertyName, _heading, value)
            End Set
        End Property

        Public Sub New(ByVal sensorService As ISensorService)
            sensorService.RegisterForHeading(Sub(_heading)
                                                 Heading = String.Format("{0:N1}°", _heading)
                                                 Debug.WriteLine(Heading)
                                             End Sub)
        End Sub
    End Class
End Namespace
