Imports System.Threading
Imports GalaSoft.MvvmLight
Imports GalaSoft.MvvmLight.Command
Imports GalaSoft.MvvmLight.Threading

Namespace MvvmMultithreading.ViewModel
	Public Class MainViewModel
		Inherits ViewModelBase
		Public Const StatusPropertyName As String = "Status"

		Private _condition As Boolean = True
		Private _startCrashCommand As RelayCommand
		Private _startSuccessCommand As RelayCommand
		Private _status As String

		Public ReadOnly Property StartCrashCommand() As RelayCommand
			Get
										' This is a background operation!
											' Do something
											' Notify user. If the Status property is databound to
											' a control in the XAML, this call will crash the app
											' except in WPF, where the call is automatically dispatched.
											' Sleep for a while
                'INSTANT VB TODO TASK: VB has no equivalent to the C# '??' operator:
                If _startCrashCommand Is Nothing Then
                    _startCrashCommand = New RelayCommand(Sub()
                                                              Dim loopIndex = 0
                                                              ThreadPool.QueueUserWorkItem(Sub(o)
                                                                                               Do While _condition
                                                                                                   Status = String.Format("Loop # {0}", loopIndex)
                                                                                                   loopIndex += 1
                                                                                                   Thread.Sleep(500)
                                                                                               Loop
                                                                                           End Sub)
                                                          End Sub)
                End If
                Return _startCrashCommand
            End Get
		End Property

		Public ReadOnly Property StartSuccessCommand() As RelayCommand
			Get
                If _startSuccessCommand Is Nothing Then
                    _startSuccessCommand = New RelayCommand(Sub()
                                                                Dim loopIndex = 0
                                                                ThreadPool.QueueUserWorkItem(Sub(o)
                                                                                                 Do While _condition
                                                                                                     DispatcherHelper.CheckBeginInvokeOnUI(Sub()
                                                                                                                                               Status = String.Format("Loop # {0}", loopIndex)
                                                                                                                                               loopIndex += 1
                                                                                                                                           End Sub)
                                                                                                     Thread.Sleep(500)
                                                                                                 Loop
                                                                                             End Sub)
                                                            End Sub)
                End If
                Return _startSuccessCommand
            End Get
        End Property

		Public Property Status() As String
			Get
				Return _status
			End Get
			Set(ByVal value As String)
                MyBase.Set(StatusPropertyName, _status, value)
            End Set
		End Property
	End Class
End Namespace
